import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Bug here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bug extends Actor
{
    /**
     * Act - do whatever the Bug wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() {
        if (getWorld().getColorAt(getX(), getY()).equals(Color.RED)) {
            Greenfoot.stop();
        } else {
            if(canMoveForward()) {
                if (wallOnLeft()) {
                    move(1);
                } else {
                    turn(-90);
                    move(1);
                }
            } else {
                if (wallOnLeft()) {
                    turn(90);
                } else {
                    turn(-90);
                    move(1);
                }
            } 
        }
    }
    
    public boolean wallOnLeft() {
        World world = getWorld();
         if (getRotation() == 0) {// facing east
            return world.getColorAt(getX(), getY() - 1).equals(Color.BLACK);
        } else if (getRotation() == 90) { // facing south
            return world.getColorAt(getX() + 1 , getY()).equals(Color.BLACK);
        } else if (getRotation() == 180) { // facing west
            return world.getColorAt(getX(), getY() + 1).equals(Color.BLACK);
        } else {
            return world.getColorAt(getX() - 1, getY()).equals(Color.BLACK);
        }
    }
    public boolean canMoveForward() {
        World world = getWorld();
        if (getRotation() == 0) {// facing east
            return !world.getColorAt(getX() + 1, getY()).equals(Color.BLACK);
        } else if (getRotation() == 90) { // facing south
            return !world.getColorAt(getX(), getY() + 1).equals(Color.BLACK);
        } else if (getRotation() == 180) { // facing west
            return !world.getColorAt(getX() - 1, getY()).equals(Color.BLACK);
        } else {
            return !world.getColorAt(getX(), getY() - 1).equals(Color.BLACK);
        }
    }
}
