import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MyWorld extends World
{
    public static final int CELL_SIZE = 20;
    
    private Actor ant;
    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    public MyWorld()
    {    
        // Create a new world with 20x20 cells with a cell size of 2 pixels.
        super(20, 20, CELL_SIZE); 
        prepare();
    }

    /**
     * Prepare the world for the start of the program.
     * That is: create the initial objects and add them to the world.
     */
    private void prepare() {
        makeMaze();
        ant = new Bug();
        addObject(ant, 1, 1);
    }
    
    public void makeMaze() {
        for (int x = 0; x < getWidth(); x++) {
            for (int y = 0; y < getHeight(); y++) {
                GreenfootImage img = new GreenfootImage(CELL_SIZE, CELL_SIZE);
                if (x == 1 && y == 1) {
                    img.setColor(Color.GREEN);
                } else if (x == getWidth() - 2 && y == getHeight() - 2) {
                    img.setColor(Color.RED);
                } else if (x == 0 || y == 0 || x == getWidth() - 1 || y == getHeight() - 1 ||Greenfoot.getRandomNumber(100) < 30) {
                    img.setColor(Color.BLACK);
                } else {
                    img.setColor(Color.WHITE);
                }
                img.fill();
               // img.setColor(Color.RED);
                //img.drawRect(0, 0, CELL_SIZE - 1, CELL_SIZE - 1);
                getBackground().drawImage(img, x * CELL_SIZE, y * CELL_SIZE);
            }
        }
    }
}
